{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE LambdaCase #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE PatternSynonyms #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.SSM.Types.DocumentFormat
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.SSM.Types.DocumentFormat
  ( DocumentFormat
      ( ..,
        DocumentFormat_JSON,
        DocumentFormat_TEXT,
        DocumentFormat_YAML
      ),
  )
where

import qualified Amazonka.Core as Core
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

newtype DocumentFormat = DocumentFormat'
  { fromDocumentFormat ::
      Data.Text
  }
  deriving stock
    ( Prelude.Show,
      Prelude.Read,
      Prelude.Eq,
      Prelude.Ord,
      Prelude.Generic
    )
  deriving newtype
    ( Prelude.Hashable,
      Prelude.NFData,
      Data.FromText,
      Data.ToText,
      Data.ToByteString,
      Data.ToLog,
      Data.ToHeader,
      Data.ToQuery,
      Data.FromJSON,
      Data.FromJSONKey,
      Data.ToJSON,
      Data.ToJSONKey,
      Data.FromXML,
      Data.ToXML
    )

pattern DocumentFormat_JSON :: DocumentFormat
pattern DocumentFormat_JSON = DocumentFormat' "JSON"

pattern DocumentFormat_TEXT :: DocumentFormat
pattern DocumentFormat_TEXT = DocumentFormat' "TEXT"

pattern DocumentFormat_YAML :: DocumentFormat
pattern DocumentFormat_YAML = DocumentFormat' "YAML"

{-# COMPLETE
  DocumentFormat_JSON,
  DocumentFormat_TEXT,
  DocumentFormat_YAML,
  DocumentFormat'
  #-}
